# Poly Roadmap

## Must have features before V1 release in order of priority

* [`insert`, `delete`, `replace` sequence methods](https://github.com/TimothyStiles/poly/issues/56) -> Tim
* [synthesis optimization](https://github.com/TimothyStiles/poly/issues/50) -> Keoni, Nick, Milo, John
* [cloning - goldengate, gibson, restriction, etc](https://github.com/TimothyStiles/poly/issues/49)
* [Primer Design CLI](https://github.com/TimothyStiles/poly/issues/43)-> Milo, Nick, John

## Will likely need before V1 release

* [SBOL3 IO](https://github.com/TimothyStiles/poly/issues/52) -> James
* wetlab test case -> Keoni

## Planned features that may be released before or after V1

* Ribosome binding site calculator
* Non-repetitive parts calculator
* RNA folding
* `store`, `search`, `track`, and `diff` functions and CLI. -> Tim, Keoni

## Future features that may or may not be implemented (pie in the sky)

* API server for enterprise interop
* Integration of published machine learning models for things like [RNA folding](https://github.com/ml4bio/e2efold)


## Stability milestones

* ~100% code coverage (currently at 94%)
* Auto-documenation of command line tools.
* Adding windows support
* Integration testing of cross format IO.
* Internationalize documentation
* Improved error handling

## Feature upgrades

* Creating default codon tables for optimization based on RNA expression rather than codon frequency in CDS regions.
* Refactor and streamline `Sequence` struct

## Community milestones

* Get 700 github stars
* Get 50 feature requests
* Merge pull requests from 20 unique contributors
* Be used by ~100 individuals or academic labs
* Be used in production in 5 small companies
* Be used in production at 1 large company
* Get 100 paying sponsors
* Get 1 large leading sponsor
* Get 5 medium corporate sponsors
* Get 10 small corporate sponsors
* Grow our discord to ~50 active users
* Our community demographics at a bare minimum should match that of the US general population.

## Marketing milestones

* Recognizable and distict logo and mascot -> Bryan, Joseph, and maybe Jeremy
* Demo videos and tutorials
* Published user stories
* Interview ~25 users
